SLASH_ARXARMCAL1  = "/ARXArmorycalibrate"	-- used to place calibration pattern on the screen for 30 seconds
SLASH_ARXARMCAL2  = "/ARXArmorycal"

SLASH_ARXARMGO1 = "/ARXArmory"				-- show target's armory page

SLASH_ARXARMVERBOSE1 = "/ARXArmoryverbose"	-- echo each playor or NPC sent, follow with 'on' or 'off'

SlashCmdList["ARXARMCAL"] = function(msg, theEditFrame)		--  calibrate
	ChatFrame1:AddMessage( "Calibration pattern set. Be sure WoW is in \"Windowed (fullscreen)\" mode.")
	ARXArmSetupGuardPixels()
	ARXArmGuardPixels(0)
	ARXArmoryxmitA1Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\04")	-- calibration pattern
	ARXArmoryxmitA2Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\05")
	ARXArmoryxmitA3Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\06")
	ARXArmoryxmitA4Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\07")
	ARXArmoryxmitA5Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\01")
	ARXArmoryxmitA6Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\02")
	ARXArmoryxmitA7Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\03")
	ARXArmoryxmitA8Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\04")
end

SlashCmdList["ARXARMVERBOSE"] = function(msg, theEditFrame)
	if msg == "off" then
		ARXArmoryVerboseMode = 0
		ChatFrame1:AddMessage("ARX Armory set to quiet mode.")
	elseif msg == "on" then
		ARXArmoryVerboseMode = 1
		ChatFrame1:AddMessage("ARX Armory set to verbose mode.")
	else
		local feedback = "ARX Armory is currently "
		if ARXArmoryVerboseMode ~= 1 then
			feedback = feedback.."not "
		end
		feedback = feedback.."in verbose mode. Follow with 'on' or 'off' to change."
		ChatFrame1:AddMessage(feedback)
	end
end

SlashCmdList["ARXARMGO"] = function(msg, theEditFrame)
	if UnitExists("target") then
		if (UnitIsPlayer("target")) then
			local targetName = GetUnitName("target", true)	-- get name & realm
			
			if string.find(targetName, "-") then		-- if player NOT on same realm, then realm appears after dash
				-- do nothing, we have the realm name included
			else
				targetName = targetName.."-"..GetRealmName()
			end
			if ARXArmoryVerboseMode == 1 then
				ChatFrame1:AddMessage("ARX Armory: Sending "..targetName.." to the app")
			end
			ARXArmSendMessage(targetName..string.char(7))  -- append ASCII 7 to indicate end of name
		else
			local guid = UnitGUID("target")
			local type, _, _, _, _, npc_id = strsplit("-",guid)  -- type: Player, Pet, Creature, and other stuff
			if type == "Creature" then
				local targetName = "NPC"..npc_id
				if ARXArmoryVerboseMode == 1 then
					ChatFrame1:AddMessage("ARX Armory: Sending "..targetName.." to the app")
				end
				ARXArmSendMessage(targetName..string.char(7))  -- append ASCII 7 to indicate end of name
			else 
				ChatFrame1:AddMessage("ARX Armory: Target a player or NPC.")
			end
		end
	else 
		ChatFrame1:AddMessage("ARX Armory: Target a player or NPC.")
	end
end

function ARXArmoryxmit_OnLoad(frame)
	frame:RegisterEvent("PLAYER_ENTERING_WORLD")	-- environment ready
	ARXArmXmitPhase = 0
	ARXArmPendingMessage = ""
	C_Timer.NewTicker(0.11, ARXArmoryTimer)			-- call infinite # of times. 9x/sec
					-- C-ticker provides more stable timing for the texture updates
end

function ARXArmoryxmit_OnEvent(frame, event, ...)
	if event == "PLAYER_ENTERING_WORLD" then		-- set stuff up
		ARXArmoryxmit:Show()
		ARXArmSetupGuardPixels()
		ARXArmGuardPixels(0)
	end
end

function ARXArmoryTimer()			-- called by C_ticker 9x/sec
	if ARXArmXmitPhase == 1 then						-- means we're sending a character
		ARXArmGuardPixels(1)
		ARXArmXmitPhase = 0

	elseif string.len(ARXArmPendingMessage) > 0 then				--else, we can fetch & post the next message
			nextMessage = string.sub(ARXArmPendingMessage,1,1)
			--print("-- just picked off <"..nextMessage.."> as next message")
			ARXArmoryPutMsgOnPixels(nextMessage)
			ARXArmGuardPixels(0)
			ARXArmPendingMessage = string.sub(ARXArmPendingMessage,2,-1)	--remove first char (or if color msg, the third)
			ARXArmXmitPhase = 1
	end
end

function ARXArmoryPutMsgOnPixels(msg)
	bitmask = 1
	theCode = string.byte(msg)
	--print("encoding plain byte " .. theCode)
	for i = 1,8 do
		if bit.band(theCode,bitmask) > 0 then		-- uses C library that Blizzard included
			_G["ARXArmoryxmitA"..i.."Texture"]:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\07")
		else
			_G["ARXArmoryxmitA"..i.."Texture"]:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\00")
		end	
		bitmask = bitmask * 2						-- proven faster than bit shifting
	end
end

function ARXArmSendMessage(message)
	ARXArmPendingMessage = ARXArmPendingMessage .. message
end

function ARXArmGuardPixels(state)
	if state == 0 then
		ARXArmoryxmitR2Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\00")
		ARXArmoryxmitL2Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\00")
	else
		ARXArmoryxmitR2Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\05")
		ARXArmoryxmitL2Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\06")
	end	
end
	
function ARXArmSetupGuardPixels()		
	ARXArmoryxmitR1Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\05")
	ARXArmoryxmitL1Texture:SetTexture("Interface\\AddOns\\ARXArmoryxmit\\06")
end
